'This module contains all information for using the Register function to register them via the XLL

' Syntax of the Register Command:
' REGISTER(module_text, procedure, type_text, function_text,
'          argument_text, macro_type, category, shortcut_text,
'          help_topic, function_help, argument_help1, argument_help2,...)
'
'
' g_rgWorksheetFuncs will use only the first 10 arguments of
'                  the Register function.
'
' This is a table of all the worksheet functions exported by this module.
' These functions are all registered (in xlAutoOpen) when you
' open the XLL. Before every string, leave a space for the
' byte count. The format of this table is the same as
' arguments two through eleven of the REGISTER function.
' g_rgWorksheetFuncsRows define the number of rows in the table. The
' g_rgWorksheetFuncsCols represents the number of columns in the table.
'
const g_rgWorksheetFuncsRows =  5 'Number of functions to be registered 
const g_rgWorksheetFuncsCols = 9   '# of arguments


dim shared  g_rgWorksheetFuncs() AS WSTRING*260
'-----------------------------------------
'Name: InitFuncParameters
'This sub initializes the function parameters
'See HelpID.INC for Constants declarations
'Note that Module name is omitted
'-----------------------------------------
SUB InitFuncParameters()
dim Group as wstring*50 = "My first xll functions"
REDIM g_rgWorksheetFuncs(0 to g_rgWorksheetFuncsRows,0 to g_rgWorksheetFuncsCols)
 'Function #1
g_rgWorksheetFuncs(0, 0) = "XL_MYFIRST"                      ' Procedure
g_rgWorksheetFuncs(0, 1) =  "UQ"                        ' type_text
g_rgWorksheetFuncs(0, 2) = "MyFirstFunction"                     ' function_text
g_rgWorksheetFuncs(0, 3) = "inString"    ' argument_text
g_rgWorksheetFuncs(0, 4) =  "1"                    ' macro_type
g_rgWorksheetFuncs(0, 5) = Group                ' category
g_rgWorksheetFuncs(0, 6) = ""                            ' shortcut_text
g_rgWorksheetFuncs(0, 7) = "" 'g_Regfunchlp & "24"                  ' help_topic
g_rgWorksheetFuncs(0, 8) = "Returns simple text "   ' function_help
 'Function #2
g_rgWorksheetFuncs(1, 0) = "XL_SUMRANGE"                      ' Procedure
g_rgWorksheetFuncs(1, 1) =  "RP"                        ' type_text
g_rgWorksheetFuncs(1, 2) = "Sumrange"                     ' function_text
g_rgWorksheetFuncs(1, 3) = "Range"    ' argument_text
g_rgWorksheetFuncs(1, 4) =  "1"                    ' macro_type
g_rgWorksheetFuncs(1, 5) = Group                ' category
g_rgWorksheetFuncs(1, 6) = ""                            ' shortcut_text
g_rgWorksheetFuncs(1, 7) = "" 'g_Regfunchlp & "24"                  ' help_topic
g_rgWorksheetFuncs(1, 8) = "Sums numbers in a range "   ' function_help

g_rgWorksheetFuncs(2, 0) = "XL_FLDSTOSTRING_UNICODE"
g_rgWorksheetFuncs(2, 1) =  "UUPP"
g_rgWorksheetFuncs(2, 2) = "FldsToString"
g_rgWorksheetFuncs(2, 3) = "Range,Separator,[extra Quotes]"
g_rgWorksheetFuncs(2, 4) =  "1"
g_rgWorksheetFuncs(2, 5) = "Text"
g_rgWorksheetFuncs(2, 6) = ""
g_rgWorksheetFuncs(2, 7) = "" 'g_Regfunchlp & "56"
g_rgWorksheetFuncs(2, 8) = "Joins converted cells into one string with separator and/or exstra string literals  " 

g_rgWorksheetFuncs(3, 0) = "XL_FASTLOOKUP"
g_rgWorksheetFuncs(3, 1) =  "RRRPR"
g_rgWorksheetFuncs(3, 2) = "FASTLOOKUP"
g_rgWorksheetFuncs(3, 3) = "Lookup_Value,TableArray,[SearchColumn],ReturnColumn"
g_rgWorksheetFuncs(3, 4) =  "1"
g_rgWorksheetFuncs(3, 5) = "Lookup & Reference"
g_rgWorksheetFuncs(3, 6) = ""
g_rgWorksheetFuncs(3, 7) =  "" 
g_rgWorksheetFuncs(3, 8) = "ala VLOOKUP, but a combination of Excel' MATCH and INDEX function. Defaults to search in column 1 in tablearray.  "

g_rgWorksheetFuncs(4, 0) = "XL_CIRCLEAREA"
g_rgWorksheetFuncs(4, 1) =  "RP"
g_rgWorksheetFuncs(4, 2) = "CircleArea"
g_rgWorksheetFuncs(4, 3) = "Radius"
g_rgWorksheetFuncs(4, 4) =  "1"
g_rgWorksheetFuncs(4, 5) = "Math & Trig"
g_rgWorksheetFuncs(4, 6) = ""
g_rgWorksheetFuncs(4, 7) =  "" 
g_rgWorksheetFuncs(4, 8) = "Calculates area of a circle  "                                                                                                                                             
end sub                                                       