'*************************************************************
'Various routines for reading and writing
'pascal strings(byte counted strings) that Excel uses
  
'Strings
'All versions of Excel:

'[signed] char *  null-terminated byte strings of up to 255 characters
'unsigned char *  length-counted byte strings of up to 255 characters
'Starting in Excel 2007:
'unsigned short *  Unicode strings of up to 32,767 characters, which can be null-terminated or length-counted
' *************************************************************  

'max chars in a unicode/widestring string in excel 2007 and up
const MAX_UNICODE_EXCEL = 32767
const  MAX_XL4_STR_LEN  = 255 'max string lenght P/R datatype ie XLOPER/OPER

'**************************************************************************************
'Copies a byte counted ZString (ASCII) by inserting number of chars in original string
'at the beginning to another Zstring. Also called a Pascal string
'**************************************************************************************
FUNCTION WritePascalStr2(BYREF zsFrom AS zSTRING, BYREF zsResult AS zsTRING) AS ZSTRING PTR
  zsResult = CHR(LEN(zsFrom)) & zsFrom
  FUNCTION = cast(ZSTRING PTR,VARPTR(zsResult))
END FUNCTION
'**************************************************************************************
'Creates a byte counted ZString (ASCII) by inserting number of chars in original string
'at the beginning. Also called a Pascal string
'**************************************************************************************
FUNCTION WritePascalStr(byref zsString AS zSTRING) AS ZSTRING PTR

dim ilen as UINT16
dim temp as ZSTRING PTR
        if(len(zsString) = 0) then  return NULL        
        ilen = len(zsString)       
        if(ilen > 255) then  ilen = 255 ' Excel strings are limited to 255 chars
        temp = cast(ZSTRING PTR,malloc(ilen + 2)) 
        memcpy(temp + 1, byval @zsString, ilen)
        temp[0] = ilen  'write length at start 
        temp[ilen+1] = 0  'add zero at end
        return temp
END FUNCTION
'**************************************************************************************
'Reads a byte counted ZString (ASCII) and returns the pointer to string without the byte count
'**************************************************************************************
FUNCTION ReadPascalStr(byval Xaddress AS LPXLOPER) AS ZSTRING PTR
dim iLen as UINT16
dim i as long
DIM bpString AS zstring PTR
dim ZSPtr as zstring PTR 
  bpString = Xaddress->val.str '
  ilen = bpString[0]  
  IF bpString[0] = 0 THEN
      FUNCTION = @str("")
     ELSE
      'allocate copy to memory  
      if ilen > MAX_XL4_STR_LEN then ilen = MAX_XL4_STR_LEN ' truncate
      ZSPtr = malloc(ilen*sizeof(zstring) + 2)   
     memcpy(ZSPtr, bpString +1,ilen*sizeof(zstring))

    ZSPtr[ilen]=0  'make it a Zstring by adding null character at the end (0 ASCII). 
    
     function =  ZSPtr 
  END IF
END FUNCTION

 'UNICODE
 '------------------------
 '19/02/13
 'Unicode/widestring XLOPER12 struct
 '-----------------------------
FUNCTION WritePascalStr2W(BYREF zsFrom AS WSTRING , BYREF zsResult AS WSTRING) AS WSTRING PTR
  zsResult = CHR(LEN(zsFrom)) & zsFrom
  FUNCTION = @zsResult
END FUNCTION

FUNCTION WritePascalStrW(BYREF zsString AS  WSTRING) AS wstring PTR

dim ilen as long
dim temp as wSTRING PTR
        if(len(zsString) = 0) then  return NULL
        
        ilen = len(zsString)         
        temp = cast(wSTRING PTR,malloc((ilen + 2)*sizeof(wstring))) 
        memcpy(temp + 1, byval @zsString, ilen*sizeof(wstring)) 
        temp[0] = ilen  'write length at start
        temp[ilen+1] = 0  'add zero at end
        return temp  
END FUNCTION




 '**************************************************************************************
'Reads a byte counted wString (ASCII) and returns the pointer to string without the byte count
'**************************************************************************************
FUNCTION ReadPascalStrW(byval Xaddress AS LPXLOPER12) AS wstring ptr

dim iLen as long

dim i as long
DIM bpString AS wstring PTR
dim ZSPtr as wstring PTR 

  bpString = Xaddress->val.str '
  ilen = bpString[0]
  
  IF bpString[0] = 0 THEN
      FUNCTION = @wstr("")
  ELSE
   'allocate  memory to copy to	
   ZSPtr = malloc((ilen + 2)*sizeof(wstring) )   
  wcsncpy(ZSPtr, bpString +1,ilen*sizeof(zstring))

 ZSPtr[ilen]=0  'make it a wstring by adding null character at the end (0 ASCII). 
 
  function =  ZSPtr 
  END IF
END FUNCTION