#pragma once

#include once "crt/long.bi"
#include once "windows.bi"
#include once "crt/malloc.bi"
#include once "crt/wchar.bi"
#include once "xlcall.bi"

'#include once "memorymanager.bi"
#include once "crt/stdarg.bi"
 '#include once "xlcallcpp.bi"
CONST MEMORYSIZE   =  10240
const rwMaxO8 = 65536
const colMaxO8 = 256
const cchMaxStz = 255
const MAXSHORTINT = &h7fff
dim SHARED  vMemBlock(MEMORYSIZE)as byte ' Memory for temporary XLOPERs
dim SHARED vOffsetMemBlock AS LONG  'integer       ' Offset of next memory block to allocate

'extern  vMemBlock AS zstring*MEMORYSIZE ' Memory for temporary XLOPERs
'extern vOffsetMemBlock AS short  'integer       ' Offset of next memory block to allocate
'dim shared vMemBlock AS zstring*MEMORYSIZE ' Memory for temporary XLOPERs
'dim shared vOffsetMemBlock AS short  'integer       ' Offset of next memory block to allocate
'DECLARE FUNCTION Excel4 Cdecl ALIAS "Excel4"(byval xlfn as long, byval operRes as LPXLOPER, byval count as long, ...) as LONG  
'DECLARE FUNCTION Excel12 CDECL ALIAS "Excel12"(byval xlfn as long, byval operRes as LPXLOPER12, byval count as long, ...) as long

'-------------------------------------------------------------------------'
'GetTempMemory()
'
' Purpose:
'           Allocates temporary memory. Temporary memory
'           can only be freed in one chunk, by calling
'           FreeAllTempMemory(). This is done by Excel().
'
' Parameters:
'
'      int cBytes      How many bytes to allocate
'
' Returns:
'
'      DWORD           A pointer to the allocated memory,
'                      or 0 if more memory cannot be
'                      allocated. If this fails,
'                      check that you are initializing
'                      vOffsetMemBlock to 0, and check that
'                      MEMORYSIZE is big enough.
'
' Comments:
'
'        Algorithm:
'
'             The memory allocation algorithm is extremely
'             simple: on each call, allocate the next cBytes
'             bytes of a static memory buffer. If the buffer
'             becomes too full, simply fail. To free memory,
'             simply reset the pointer (vOffsetMemBlock)
'             back to zero. This memory scheme is very fast
'             and is optimized for the assumption that the
'             only thing you are using temporary memory
'             for is to hold arguments while you call Excel().
'             We rely on the fact that you will free all the
'             temporary memory at the same time. We also
'             assume you will not need more memory than
'             the amount required to hold a few arguments
'             to Excel().
'
'-------------------------------------------------------------------------

 'extern "C"
FUNCTION GetTempMemory(cBytes AS long) AS LPSTR

     DIM lpMemory AS LPSTR
      
    IF (vOffsetMemBlock + cBytes > MEMORYSIZE) THEN
            
        vOffsetMemBlock = 0
      
        lpMemory = varptr(vMemBlock(0)) +  vOffsetMemBlock
        vOffsetMemBlock += cBytes
    ELSE
       
        lpMemory = varptr(vMemBlock(0)) +  vOffsetMemBlock
         
        vOffsetMemBlock +=  cBytes

        ' Prevent odd pointers */
        'if (vOffsetMemBlock & 1) vOffsetMemBlock++'
         
        'IF vOffsetMemBlock MOD 2 <> 0 THEN vOffsetMemBlock +=  1
        IF (vOffsetMemBlock and 1) THEN vOffsetMemBlock +=  1
    END IF
    
       
FUNCTION =  lpMemory
     
END FUNCTION
'end extern 
'-------------------------------------------------------------------------
' FreeAllTempMemory()
'
' Purpose:
'
'          Frees all temporary memory that has been allocated
'
' Parameters:
'
' Returns:
'
' Comments:
'
'      Unlike the usual string functions, lpstricmp
'      doesn't care about collating sequence.
'
'-------------------------------------------------------------------------
SUB FreeAllTempMemory()
    vOffsetMemBlock = 0

END SUB
                            




'' TODO: int cdecl Excel(int xlfn, LPXLOPER pxResult, int count, ...){ int xlret; va_list ppxArgs; va_start(ppxArgs, count); xlret = Excel4v(xlfn,pxResult,count,(LPXLOPER *)ppxArgs); va_end(ppxArgs); FreeAllTempMemory(); return xlret;}
'' TODO: int cdecl Excel12f(int xlfn, LPXLOPER12 pxResult, int count, ...){ int xlret; va_list ppxArgs; va_start(ppxArgs, count); xlret = Excel12v(xlfn,pxResult,count,(LPXLOPER12 *)ppxArgs); va_end(ppxArgs); FreeAllTempMemory(); return xlret;}
'///***************************************************************************
'// TempNum()
'//
'// Purpose: 
'//      Creates a temporary numeric (IEEE floating point) XLOPER.
'//
'// Parameters:
'//
'//      double d        The value
'//
'// Returns: 
'//
'//      LPXLOPER        The temporary XLOPER, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'///***************************************************************************
 function TempNum(byval d as double) as LPXLOPER
	DIM  lpx AS LPXLOPER
	lpx = cast(LPXLOPER,GetTempMemory(SIZEOF(XLOPER)))
	if lpx = 0 then
		return 0
	end if
	lpx->xltype = xltypeNum
	lpx->val.num = d
	return lpx
end function
' ///***************************************************************************
'// TempNum12()
'//
'// Purpose: 
'//      Creates a temporary numeric (IEEE floating point) XLOPER12.
'//
'// Parameters:
'//
'//      double d        The value
'//
'// Returns: 
'//
'//      LPXLOPER12      The temporary XLOPER12, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//		
'//
'///***************************************************************************

 function TempNum12(byval d as double) as LPXLOPER12
	DIM lpx AS LPXLOPER12 
	lpx = cast(LPXLOPER12,GetTempMemory(SIZEOF(XLOPER12)))
	if lpx = 0 then
		return 0
	end if
	lpx->xltype = xltypeNum
	lpx->val.num = d
	return lpx
end function

'-------------------------------------------------------------------------
' TempStr()
'
' Purpose:
'          Creates a temporary string XLOPER
'
' Parameters:
'
'      LPSTR lpstr     The string, as a null-terminated
'                      C string, with the first byte
'                      undefined. This function will
'                      count the bytes of the string
'                      and insert that count in the
'                      first byte of lpstr. Excel cannot
'                      handle strings longer than 255
'                      characters.
'
' Returns:
'
'      LPXLOPER        The temporary XLOPER, or 0
'                      if GetTempMemory() failed.
'
' Comments:
'
'      (1) This function has the assumes that the function is already byte counted                 NB NB NB
'
'      (2) For highest speed, with constant strings,
'          you may want to manually count the length of
'          the string before compiling, and then avoid
'          using this function.
'
'      (3) Behavior is undefined for non-null terminated
'          input or strings longer than 255 characters.
'
'-------------------------------------------------------------------------
FUNCTION  TempStr(zsTemp AS zstring) AS LPXLOPER

    DIM  lpx AS LPXLOPER
    

lpx = cast(LPXLOPER,GetTempMemory(SIZEOF(LPXLOPER)))


    lpx->xltype = xltypeStr
	lpx->val.str = varptr(zsTemp)
    print zsTemp 
   FUNCTION = lpx
END FUNCTION
'///***************************************************************************
'// TempStrConst()
'//
'// Purpose: 
'//      Creates a temporary string XLOPER from a
'//      const string with a local copy in temp memory
'//
'// Parameters:
'//
'//      LPSTR lpstr     The string, as a null-terminated
'//                      C string. This function will
'//                      count the bytes of the string
'//                      and insert that count in the
'//                      first byte of the temp string.
'//                      Excel cannot handle strings
'//                      longer than 255 characters.
'//
'// Returns: 
'//
'//      LPXLOPER        The temporary XLOPER, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'//      Will take a string of the form "abc\0" and make a
'//      temp XLOPER of the form "\003abc"
'//
'//
'///***************************************************************************
                  
 function TempStrConst(byref zTemp as const zstring) as LPXLOPER
	DIM lpx AS LPXLOPER 
	DIM lps AS LPSTR 
	dim ilen as LONG
	ilen = len(zTemp)
	lpx = cast(LPXLOPER,GetTempMemory(sizeof(XLOPER) + ilen+1))
	if lpx = 0 then
		return 0
	end if
	lps = cast(LPSTR,lpx + sizeof(XLOPER))
	lps[0] = iLEN
	'memcpy_s(lps + 1, ilen + 1, lpstr, ilen)
   
   POKE  zstring, lps+1,zTemp  
	lpx->xltype = xltypeStr
	lpx->val.str = lps
	return lpx
end function
' ///***************************************************************************
'// TempStr12()
'//
'// Purpose: 
'//      Creates a temporary string XLOPER12 from a
'//      unicode const string with a local copy in
'//      temp memory
'//
'// Parameters:
'//
'//      XCHAR lpstr     The string, as a null-terminated
'//                      unicode string. This function will
'//                      count the bytes of the string
'//                      and insert that count in the
'//                      first byte of the temp string.
'//
'// Returns: 
'//
'//      LPXLOPER12      The temporary XLOPER12, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'//      (1) Fix for const string pointers being passed in to TempStr.
'//          Note it assumes NO leading space
'//
'//      (2) Also note that XLOPER12 now uses unicode for the string
'//          operators
'//
'//      (3) Will remove the null-termination on the string
'//
'//
'//
'// Note: TempStr12 is different from TempStr and is more like TempStrConst
'// in its behavior. We have consciously made this choice and deprecated the
'// behavior of TempStr going forward. Refer to the note in comment section
'// for TempStr to better understand this design decision.
'///***************************************************************************
 'function TempStr12( byref wzTemp as const wstring) as LPXLOPER12
  function TempStr12(byref wzTemp as const wstring) as LPXLOPER12
	DIM  lpx AS LPXLOPER12
	'XCHAR * lps
   dim lps as wstring ptr
	dim ilen as LONG
	ilen = lstrlenW(wzTemp)
   
	lpx = cast(LPXLOPER12,GetTempMemory(sizeof(XLOPER12) + (ilen+1)*2))
	if lpx = 0 then
		return 0
	end if
	'lps = cptr(XCHAR ptr, cptr(CHAR ptr, lpx) + sizeof(XLOPER12))
   lps = cast(wstring ptr,lpx + sizeof(XLOPER12))
	lps[0] = cbyte(iLEN )
  
	'wmemcpy(lps + 1, ilen + 1, lpstr, ilen)
   poke wstring , lps + 1 ,wzTemp
  
	lpx->xltype = xltypeStr
	lpx->val.str = lps
	return lpx
end function
' ///***************************************************************************
'// TempBool()
'//
'// Purpose: 
'//      Creates a temporary logical (true/false) XLOPER.
'//
'// Parameters:
'//
'//      int b           0 - for a FALSE XLOPER
'//                      Anything else - for a TRUE XLOPER
'//
'// Returns: 
'//
'//      LPXLOPER        The temporary XLOPER, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'///***************************************************************************
 function TempBool(byref b as long) as LPXLOPER
	DIM lpx AS LPXLOPER 
	lpx = cast(LPXLOPER,GetTempMemory(SIZEOF(XLOPER)))
	if lpx = 0 then
		return 0
	end if
	lpx->xltype = xltypeBool
	lpx->val.bool = iif(b, 1, 0)
	return lpx
end function
' ///***************************************************************************
'// TempBool12()
'//
'// Purpose: 
'//      Creates a temporary logical (true/false) XLOPER12.
'//
'// Parameters:
'//
'//      BOOL b          0 - for a FALSE XLOPER12
'//                      Anything else - for a TRUE XLOPER12
'//
'// Returns: 
'//
'//      LPXLOPER12      The temporary XLOPER12, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'///***************************************************************************

 function TempBool12(byval b as BOOL) as LPXLOPER12
	DIM  lpx AS LPXLOPER12
	lpx = cast(LPXLOPER12,GetTempMemory(sizeof(XLOPER12)))
	if lpx = 0 then
		return 0
	end if
	lpx->xltype = xltypeBool
	lpx->val.xbool = iif(b, 1, 0)
	return lpx
end function
'///***************************************************************************
'// TempInt()
'//
'// Purpose: 
'//      Creates a temporary integer XLOPER.
'//
'// Parameters:
'//
'//      short int i     The integer
'//
'// Returns: 
'//
'//      LPXLOPER        The temporary XLOPER, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'///***************************************************************************
 function TempInt(byval i as short) as LPXLOPER
	DIM lpx AS LPXLOPER 
      
	lpx = cptr(LPXLOPER,GetTempMemory(sizeof(XLOPER)))
       
	if lpx = 0 then
       
		return 0
	end if
	lpx->xltype = xltypeInt
	lpx->val.w = i
   
	return lpx
  
end function



'///***************************************************************************
'// TempInt12()
'//
'// Purpose: 
'//          Creates a temporary integer XLOPER12.
'//
'// Parameters:
'//
'//      int i           The integer
'//
'// Returns: 
'//
'//      LPXLOPER12      The temporary XLOPER12, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'//      Note that the int oper has increased in size from
'//      short int up to int in the 12 opers
'//
'///***************************************************************************
 function TempInt12(byval i as long) as LPXLOPER12
	DIM  lpx  AS LPXLOPER12
	lpx = cptr(LPXLOPER12,GetTempMemory(sizeof(XLOPER12)))
	if lpx = 0 then
		return 0
	end if
	lpx->xltype = xltypeInt
	lpx->val.w = i
	return lpx
end function
'///***************************************************************************
'// TempErr()
'//
'// Purpose: 
'//      Creates a temporary error XLOPER.
'//
'// Parameters:
'//
'//      WORD err        The error code. One of the xlerr...
'//                      constants, as defined in XLCALL.H.
'//                      See the Excel user manual for
'//                      descriptions about the interpretation
'//                      of various error codes.
'//
'// Returns: 
'//
'//      LPXLOPER        The temporary XLOPER, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'///***************************************************************************
 function TempErr(byval berr as WORD) as LPXLOPER
	DIM lpx AS LPXLOPER 
	lpx = cast(LPXLOPER,GetTempMemory(sizeof(XLOPER)))
	if lpx = 0 then
		return 0
	end if
	lpx->xltype = xltypeErr
	lpx->val.err = berr
	return lpx
end function
'///***************************************************************************
'// TempErr12()
'//
'// Purpose: 
'//      Creates a temporary error XLOPER12.
'//
'// Parameters:
'//
'//      int err         The error code. One of the xlerr...
'//                      constants, as defined in XLCALL.H.
'//                      See the Excel user manual for
'//                      descriptions about the interpretation
'//                      of various error codes.
'//
'// Returns: 
'//
'//      LPXLOPER12      The temporary XLOPER12, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'//      Note the paramater has changed from a WORD to an int
'//      in the new 12 operators
'//
'///***************************************************************************
 function TempErr12(byval berr as long) as LPXLOPER12
	DIM  lpx  AS LPXLOPER12
	lpx = cast(LPXLOPER12,GetTempMemory(sizeof(XLOPER12)))
	if lpx = 0 then
		return 0
	end if
	lpx->xltype = xltypeErr
	lpx->val.err = berr
	return lpx
end function
'///***************************************************************************
'// TempActiveRef()
'//
'// Purpose: 
'//      Creates a temporary rectangular reference to the active
'//      sheet. Remember that the active sheet is the sheet that
'//      the user sees in front, not the sheet that is currently
'//      being calculated.
'//
'// Parameters:
'//
'//      WORD rwFirst    (0 based) The first row in the rectangle.
'//      WORD rwLast     (0 based) The last row in the rectangle.
'//      BYTE colFirst   (0 based) The first column in the rectangle.
'//      BYTE colLast    (0 based) The last column in the rectangle.
'//
'// Returns: 
'//
'//      LPXLOPER        The temporary XLOPER, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'///***************************************************************************
 function TempActiveRef(byval rwFirst as WORD, byval rwLast as WORD, byval colFirst as BYTE, byval colLast as BYTE) as LPXLOPER
	DIM lpx AS LPXLOPER 
	DIM  lpmref AS LPXLMREF
	dim wRet as long
	lpx = cast(LPXLOPER,GetTempMemory(sizeof(XLOPER)))
	lpmref = cast(LPXLMREF,GetTempMemory(sizeof(XLMREF)))
	if lpmref = 0 then
		return 0
	end if
	wRet = Excel4(xlSheetId, lpx, 0)
	if wRet <> xlretSuccess then
		return 0
	else
		lpx->xltype = xltypeRef
		lpx->val.mref.lpmref = lpmref
		lpmref->count = 1
		lpmref->reftbl(0).rwFirst = rwFirst
		lpmref->reftbl(0).rwLast = rwLast
		lpmref->reftbl(0).colFirst = colFirst
		lpmref->reftbl(0).colLast = colLast
		return lpx
	end if
end function
'///***************************************************************************
'// TempActiveRef12()
'//
'// Purpose: 
'//      Creates a temporary rectangular reference to the active
'//      sheet. Remember that the active sheet is the sheet that
'//      the user sees in front, not the sheet that is currently
'//      being calculated.
'//
'// Parameters:
'//
'//      RW rwFirst      (0 based) The first row in the rectangle.
'//      RW rwLast       (0 based) The last row in the rectangle.
'//      COL colFirst    (0 based) The first column in the rectangle.
'//      COL colLast     (0 based) The last column in the rectangle.
'//
'// Returns: 
'//
'//      LPXLOPER12      The temporary XLOPER12, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'//      Note that the formal parameters have changed for Excel 2007
'//      The valid size has increased to accomodate the increase 
'//      in Excel 2007 workbook sizes
'//
'///***************************************************************************
 function TempActiveRef12(byval rwFirst as RW, byval rwLast as RW, byval colFirst as COL, byval colLast as COL) as LPXLOPER12
	DIM lpx AS LPXLOPER12 
	DIM  lpmref AS LPXLMREF12
	dim wRet as long
	lpx = cast(LPXLOPER12,GetTempMemory(sizeof(XLOPER12)))
	lpmref = cast(LPXLMREF12,GetTempMemory(sizeof(XLMREF12)))
	if lpmref = 0 then
		return 0
	end if
	wRet = Excel12(xlSheetId, lpx, 0)
	if wRet <> xlretSuccess then
		return 0
	else
		lpx->xltype = xltypeRef
		lpx->val.mref.lpmref = lpmref
		lpmref->count = 1
		lpmref->reftbl(0).rwFirst = rwFirst
		lpmref->reftbl(0).rwLast = rwLast
		lpmref->reftbl(0).colFirst = colFirst
		lpmref->reftbl(0).colLast = colLast
		return lpx
	end if
end function
'///***************************************************************************
'// TempActiveCell()
'//
'// Purpose: 
'//      Creates a temporary reference to a single cell on the active
'//      sheet. Remember that the active sheet is the sheet that
'//      the user sees in front, not the sheet that is currently
'//      being calculated.
'//
'// Parameters:
'//
'//      WORD rw         (0 based) The row of the cell.
'//      BYTE col        (0 based) The column of the cell.
'//
'// Returns: 
'//
'//      LPXLOPER        The temporary XLOPER, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'///***************************************************************************
 function TempActiveCell(byval rw as WORD, byval col as BYTE) as LPXLOPER
	return TempActiveRef(rw, rw, col, col)
end function

 function TempActiveCell12(byval rw as RW, byval col as COL) as LPXLOPER12
	return TempActiveRef12(rw, rw, col, col)
end function

 function TempActiveRow(byval rw as WORD) as LPXLOPER
	return TempActiveRef(rw, rw, 0, &hFF)
end function

 function TempActiveRow12(byval rw as RW) as LPXLOPER12
	return TempActiveRef12(rw, rw, 0, &h00003FFF)
end function

 function TempActiveColumn(byval col as BYTE) as LPXLOPER
	return TempActiveRef(0, &hFFFF, col, col)
end function

 function TempActiveColumn12(byval col as COL) as LPXLOPER12
	return TempActiveRef12(0, &h000FFFFF, col, col)
end function
'///***************************************************************************
'// TempMissing()
'//
'// Purpose: 
'//      This is used to simulate a missing argument when
'//      calling Excel(). It creates a temporary
'//      "missing" XLOPER.
'//
'// Parameters:
'//
'// Returns: 
'//
'//      LPXLOPER        The temporary XLOPER, or 0
'//                      if GetTempMemory() failed.
'//
'// Comments:
'//
'///***************************************************************************
 function TempMissing() as LPXLOPER
	DIM lpx AS LPXLOPER 
	lpx = cast(LPXLOPER,GetTempMemory(sizeof(XLOPER)))
	if lpx = 0 then
		return 0
	end if
	lpx->xltype = xltypeMissing
	return lpx
end function

 function TempMissing12() as LPXLOPER12
	DIM lpx AS LPXLOPER12 
	lpx = cast(LPXLOPER12,GetTempMemory(sizeof(XLOPER12)))
	if lpx = 0 then
		return 0
	end if
	lpx->xltype = xltypeMissing
	return lpx
end function

 sub InitFramework()
	FreeAllTempMemory()
end sub

 sub QuitFramework()
	FreeAllTempMemory()
end sub

sub FreeXLOperT(byval pxloper as LPXLOPER)
	DIM xltype AS WORD 
	DIM cxloper as long
	DIM  pxloperFree AS LPXLOPER
	xltype = pxloper->xltype

   SELECT CASE  xltype
      CASE xltypeStr
         IF pxloper->val.str <> NULL THEN free(pxloper->val.str)
      case xltypeRef   
         IF pxloper->val.mref.lpmref <> NULL THEN  free(pxloper->val.mref.lpmref)
      CASE  xltypeMulti
         cxloper = pxloper->val.array.rows * pxloper->val.array.columns
         IF pxloper->val.array.lparray <> NULL THEN 
            pxloperFree = pxloper->val.array.lparray
            WHILE cxloper > 0 
               FreeXLOperT(pxloperFree)
               pxloperFree += 1
               cxloper    -= 1
            WEND
             FREE(pxloper->val.array.lparray)
         ENDIF
      CASE xltypeBigData
         if pxloper->val.bigdata.h.lpbData <>NULL THEN  FREE(pxloper->val.bigdata.h.lpbData)
   END SELECT

end sub

 sub FreeXLOper12T(byval pxloper12 as LPXLOPER12)
	DIM xltype AS DWORD 
	dim cxloper12 as long
	DIM pxloper12Free AS LPXLOPER12 
	xltype = pxloper12->xltype

SELECT CASE xltype
   case xltypeStr
      if (pxloper12->val.str <> NULL) THEN free(pxloper12->val.str)
   case xltypeRef
      if (pxloper12->val.mref.lpmref <>NULL) THEN free(pxloper12->val.mref.lpmref)
   case xltypeMulti
      cxloper12 = pxloper12->val.array.rows * pxloper12->val.array.columns
      if (pxloper12->val.array.lparray) THEN
         pxloper12Free = pxloper12->val.array.lparray
         while (cxloper12 > 0)
             FreeXLOper12T(pxloper12Free)
             pxloper12Free += 1
             cxloper12-= 1
         WEND
         free(pxloper12->val.array.lparray)
      ENDIF
   case xltypeBigData
      if (pxloper12->val.bigdata.h.lpbData <>NULL) THEN free(pxloper12->val.bigdata.h.lpbData)
END SELECT
end sub

 function ConvertXLRefToXLRef12(byval pxref as LPXLREF, byval pxref12 as LPXLREF12) as BOOL
	if (pxref->rwLast >= pxref->rwFirst) andalso (pxref->colLast >= pxref->colFirst) then
		if (pxref->rwFirst >= 0) andalso (pxref->colFirst >= 0) then
			pxref12->rwFirst = pxref->rwFirst
			pxref12->rwLast = pxref->rwLast
			pxref12->colFirst = pxref->colFirst
			pxref12->colLast = pxref->colLast
			return TRUE
		end if
	end if
	return FALSE
end function

 function ConvertXLRef12ToXLRef(byval pxref12 as LPXLREF12, byval pxref as LPXLREF) as BOOL
	if (pxref12->rwLast >= pxref12->rwFirst) andalso (pxref12->colLast >= pxref12->colFirst) then
		if (pxref12->rwFirst >= 0) andalso (pxref12->colFirst >= 0) then
			if (pxref12->rwLast < rwMaxO8) andalso (pxref12->colLast < colMaxO8) then
				pxref->rwFirst = pxref12->rwFirst  '(WORD)
				pxref->rwLast = pxref12->rwLast '(WORD)
				pxref->colFirst = pxref12->colFirst   '(BYTE)
				pxref->colLast = pxref12->colLast  '(BYTE)
				pxref->rwFirst = pxref12->rwFirst
				pxref->rwLast = pxref12->rwLast
				pxref->colFirst = pxref12->colFirst
				 pxref->colLast = pxref12->colLast
				return TRUE
			end if
		end if
	end if
	return FALSE
end function

' function XLOper12ToXLOper(byval pxloper12 as LPXLOPER12, byval pxloper as LPXLOPER) as BOOL
'	dim  fRet as BOOL
'	dim  fClean as BOOL
'	dim  xltype as DWORD
'	dim cref as WORD 
'	dim cxloper12 as long
'	dim crw as RW 
'	dim ccol as COL 
'	dim cbyte as clong
'	XCHAR * st
'	dim ast as zstring ptr
'	dim cch as long
'	dim cach as byte
'	BYTE * pbyte
'	'' TODO: LPXLMREF pmref;
'	'' TODO: LPXLREF12 pref12;
'	'' TODO: LPXLREF rgref;
'	'' TODO: LPXLREF pref;
'	'' TODO: LPXLOPER rgxloperConv;
'	'' TODO: LPXLOPER pxloperConv;
'	'' TODO: LPXLOPER12 pxloper12Conv;
'	fClean = FALSE
'	fRet = TRUE
'	xltype = pxloper12->xltype
'	'' TODO: switch (xltype) { case xltypeNum: pxloper->val.num = pxloper12->val.num; break; case xltypeBool: pxloper->val.bool = pxloper12->val.xbool; break; case xltypeErr: if (pxloper12->val.err > MAXWORD) { fRet = FALSE; } else { pxloper->val.err = (WORD)pxloper12->val.err; } break; case xltypeMissing: case xltypeNil: break; case xltypeInt: if ((pxloper12->val.w + MAXSHORTINT + 1) >> 16) { pxloper->val.num = (float)pxloper12->val.w; xltype = xltypeNum; } else { pxloper->val.w = (short int)pxloper12->val.w; } break; case xltypeStr: st = pxloper12->val.str; cch = st[0]; cach = (BYTE)cch; if (cch > cchMaxStz || cch < 0) { fRet = FALSE; } else { ast = malloc((cach + 2) * sizeof(char)); if (ast == NULL) { fRet = FALSE; } else { WideCharToMultiByte(CP_ACP, 0, st + 1, cch, ast + 1, cach, NULL, NULL); ast[0] = cach; ast[cach + 1] = '\0'; pxloper->val.str = ast; } } break; case xltypeFlow: if (pxloper12->val.flow.rw > rwMaxO8 || pxloper12->val.flow.col > colMaxO8) { fRet = FALSE; } else { pxloper->val.flow.rw = (WORD)pxloper12->val.flow.rw; pxloper->val.flow.col = (BYTE)pxloper12->val.flow.col; pxloper->val.flow.xlflow = pxloper12->val.flow.xlflow; pxloper->val.flow.valflow.idSheet = pxloper12->val.flow.valflow.idSheet; } break; case xltypeRef: if (pxloper12->val.mref.lpmref && pxloper12->val.mref.lpmref->count > 0) { pref12 = pxloper12->val.mref.lpmref->reftbl; cref = pxloper12->val.mref.lpmref->count; pmref = (LPXLMREF) malloc(sizeof(XLMREF) + sizeof(XLREF)*(cref-1)); if (pmref == NULL) { fRet = FALSE; } else { pmref->count = cref; rgref = pmref->reftbl; pref = rgref; while (cref > 0 && !fClean) { if (!ConvertXLRef12ToXLRef(pref12, pref)) { fClean = TRUE; cref = 0; } else { pref++; pref12++; cref--; } } if (fClean) { free(pmref); fRet = FALSE; } else { pxloper->val.mref.lpmref = pmref; pxloper->val.mref.idSheet = pxloper12->val.mref.idSheet; } } } else { xltype = xltypeMissing; } break; case xltypeSRef: if (pxloper12->val.sref.count != 1) { fRet = FALSE; } else if (ConvertXLRef12ToXLRef(&pxloper12->val.sref.ref, &pxloper->val.sref.ref)) { pxloper->val.sref.count = 1; } else { fRet = FALSE; } break; case xltypeMulti: crw = pxloper12->val.array.rows; ccol = pxloper12->val.array.columns; if (crw > rwMaxO8 || ccol > colMaxO8) { fRet = FALSE; } else { cxloper12 = crw * ccol; if (cxloper12 == 0) { xltype = xltypeMissing; } else { rgxloperConv = malloc(cxloper12 * sizeof(XLOPER)); if (rgxloperConv == NULL) { fRet = FALSE; } else { pxloperConv = rgxloperConv; pxloper12Conv = pxloper12->val.array.lparray; while (cxloper12 > 0 && !fClean) { if (!XLOper12ToXLOper(pxloper12Conv, pxloperConv)) { fClean = TRUE; cxloper12 = 0; } else { pxloperConv++; pxloper12Conv++; cxloper12--; } } if (fClean) { fRet = FALSE; while (pxloperConv > rgxloperConv) { FreeXLOperT(pxloperConv); pxloperConv--; } free(rgxloperConv); } else { pxloper->val.array.lparray = rgxloperConv; pxloper->val.array.rows = crw; pxloper->val.array.columns = ccol; } } } } break; case xltypeBigData: cbyte = pxloper12->val.bigdata.cbData; if (pxloper12->val.bigdata.h.lpbData != NULL && cbyte > 0) { pbyte = (BYTE *)malloc(cbyte); if (pbyte != NULL) { memcpy_s(pbyte, cbyte, pxloper12->val.bigdata.h.lpbData, cbyte); pxloper->val.bigdata.h.lpbData = pbyte; pxloper->val.bigdata.cbData = cbyte; } else { fRet = FALSE; } } else { fRet = FALSE; } break; }
'	if fRet then
'		'' TODO: pxloper->xltype = (WORD)xltype;
'	end if
'	return fRet
'end function

' function XLOperToXLOper12(byval pxloper as LPXLOPER, byval pxloper12 as LPXLOPER12) as BOOL
'	'' TODO: BOOL fRet;
'	'' TODO: BOOL fClean;
'	'' TODO: WORD crw;
'	'' TODO: WORD ccol;
'	'' TODO: WORD cxloper;
'	'' TODO: WORD cref12;
'	'' TODO: DWORD xltype;
'	BYTE * pbyte
'	dim ast as const zstring ptr
'	XCHAR * st
'	dim cach as long
'	dim cch as long
'	dim cbyte as clong
'	'' TODO: LPXLREF pref;
'	'' TODO: LPXLREF12 pref12;
'	'' TODO: LPXLREF12 rgref12;
'	'' TODO: LPXLMREF12 pmref12;
'	'' TODO: LPXLOPER pxloperConv;
'	'' TODO: LPXLOPER12 rgxloper12Conv;
'	'' TODO: LPXLOPER12 pxloper12Conv;
'	fClean = FALSE
'	fRet = TRUE
'	xltype = pxloper->xltype
'	'' TODO: switch (xltype) { case xltypeNum: pxloper12->val.num = pxloper->val.num; break; case xltypeBool: pxloper12->val.xbool = pxloper->val.bool; break; case xltypeErr: pxloper12->val.err = (int)pxloper->val.err; break; case xltypeMissing: case xltypeNil: break; case xltypeInt: pxloper12->val.w = pxloper->val.w; case xltypeStr: ast = pxloper->val.str; if (ast == NULL) { fRet = FALSE; } else { cach = ast[0]; cch = cach; if (cach > cchMaxStz || cach < 0) { fRet = FALSE; } else { st = (XCHAR*) malloc((cch + 2) * sizeof(XCHAR)); if (st == NULL) { fRet = FALSE; } else { MultiByteToWideChar(CP_ACP, 0, ast + 1, cach, st + 1, cch); st[0] = (XCHAR) cch; st[cch + 1] = '\0'; pxloper12->val.str = st; } } } break; case xltypeFlow: pxloper12->val.flow.rw = pxloper->val.flow.rw; pxloper12->val.flow.col = pxloper->val.flow.col; pxloper12->val.flow.xlflow = pxloper->val.flow.xlflow; break; case xltypeRef: if (pxloper->val.mref.lpmref && pxloper->val.mref.lpmref->count > 0) { pref = pxloper->val.mref.lpmref->reftbl; cref12 = pxloper->val.mref.lpmref->count; pmref12 = (LPXLMREF12) malloc(sizeof(XLMREF12) + sizeof(XLREF12)*(cref12-1)); if (pmref12 == NULL) { fRet = FALSE; } else { pmref12->count = cref12; rgref12 = pmref12->reftbl; pref12 = rgref12; while (cref12 > 0 && !fClean) { if (!ConvertXLRefToXLRef12(pref, pref12)) { fClean = TRUE; cref12 = 0; } else { pref++; pref12++; cref12--; } } if (fClean) { free(pmref12); fRet = FALSE; } else { pxloper12->val.mref.lpmref = pmref12; pxloper12->val.mref.idSheet = pxloper->val.mref.idSheet; } } } else { xltype = xltypeMissing; } break; case xltypeSRef: if (pxloper->val.sref.count != 1) { fRet = FALSE; } else if (ConvertXLRefToXLRef12(&pxloper->val.sref.ref, &pxloper12->val.sref.ref)) { pxloper12->val.sref.count = 1; } else { fRet = FALSE; } break; case xltypeMulti: crw = pxloper->val.array.rows; ccol = pxloper->val.array.columns; if (crw > rwMaxO8 || ccol > colMaxO8) { fRet = FALSE; } else { cxloper = crw * ccol; if (cxloper == 0) { xltype = xltypeMissing; } else { rgxloper12Conv = malloc(cxloper * sizeof(XLOPER12)); if (rgxloper12Conv == NULL) { fRet = FALSE; } else { pxloper12Conv = rgxloper12Conv; pxloperConv = pxloper->val.array.lparray; while (cxloper > 0 && !fClean) { if (!XLOperToXLOper12(pxloperConv, pxloper12Conv)) { fClean = TRUE; cxloper = 0; } else { pxloperConv++; pxloper12Conv++; cxloper--; } } if (fClean) { fRet = FALSE; while (pxloper12Conv > rgxloper12Conv) { FreeXLOperT(pxloperConv); pxloperConv--; } free(rgxloper12Conv); } else { pxloper12->val.array.lparray = rgxloper12Conv; pxloper12->val.array.rows = crw; pxloper12->val.array.columns = ccol; } } } } break; case xltypeBigData: cbyte = pxloper->val.bigdata.cbData; if (pxloper->val.bigdata.h.lpbData != NULL && cbyte > 0) { pbyte = (BYTE *)malloc(cbyte); if (pbyte != NULL) { memcpy_s(pbyte, cbyte, pxloper->val.bigdata.h.lpbData, cbyte); pxloper12->val.bigdata.h.lpbData = pbyte; pxloper12->val.bigdata.cbData = cbyte; } else { fRet = FALSE; } } else { fRet = FALSE; } break; }
'	if fRet then
'		pxloper12->xltype = xltype
'	end if
'	return fRet
'end function

'end extern
